#include<stdio.h>
#include<string.h>
#include "param.h"

void read_data_file(char *file_name)
{
  FILE *in_file;
  char tag[80];
  char value[80];

  Image_Name[0] = 0;
  Num_Orientations = 4;
  Levels = 4;
  Threshold = 0;
  Sigma_c = 1.3;
  Sigma_s = 1.3;
  I_Contrast = 1;
  O_Contrast = 1;
  Min_Radius = 2;
  Max_Radius = 0;
  O_Target = 180;
  Output = 1;
  Output_Image[0] = 0;
  CS_Ratio = 3;

  in_file = fopen(file_name, "r");

  while(!feof(in_file))
  {
    fscanf(in_file, "%s = %s\n", tag, value);

    if (!strcmp("IMAGE_NAME", tag))
    {
      strcpy(Image_Name, value);
      printf("Image_Name: %s\n", Image_Name);
    }

    else if (!strcmp("NUM_ORIENTATIONS", tag))
    {
      sscanf(value, "%d", &Num_Orientations);
      printf("Num_Orientations: %d\n", Num_Orientations);
    }

    else if (!strcmp("LEVELS", tag))
    {
      sscanf(value, "%d", &Levels);
      printf("Levels: %d\n", Levels);
    }

    else if (!strcmp("SIGMA_C", tag))
    {
      sscanf(value, "%lf", &Sigma_c);
      printf("Sigma_c: %g\n", Sigma_c);
    }

    else if (!strcmp("SIGMA_S", tag))
    {
      sscanf(value, "%lf", &Sigma_s);
      printf("Sigma_s: %g\n", Sigma_s);
    }

    else if (!strcmp("INTENSITY_CONTRAST", tag))
    {
      sscanf(value, "%d", &I_Contrast);
      printf("Intensity Contrast: %d\n", I_Contrast);
    }

    else if (!strcmp("ORIENTATION_CONTRAST", tag))
    {
      sscanf(value, "%d", &O_Contrast);
      printf("Orientation Contrast: %d\n", O_Contrast);
    }

    else if (!strcmp("MIN_RADIUS", tag))
    {
      sscanf(value, "%d", &Min_Radius);
      printf("Min_Radius: %d\n", Min_Radius);
    }

    else if (!strcmp("MAX_RADIUS", tag))
    {
      sscanf(value, "%d", &Max_Radius);
      printf("Max_Radius: %d\n", Max_Radius);
    }
    
    else if (!strcmp("O_TARGET", tag))
    {
      sscanf(value, "%d", &O_Target);
      printf("O_Target: %d\n", O_Target);
    }

    else if(!strcmp("THRESHOLD", tag))
    {
      sscanf(value, "%d", &Threshold);
      printf("Threshold: %d\n", Threshold);
    }

    else if(!strcmp("OUTPUT", tag))
    {
      sscanf(value, "%d", &Output);
      printf("Output: %d\n", Output);
    }

    else if (!strcmp("OUTPUT_IMAGE", tag))
    {
      strcpy(Output_Image, value);
      printf("Output_Image: %s\n", Output_Image);
    }

    else if (!strcmp("CS_RATIO", tag))
    {
      sscanf(value, "%d", &CS_Ratio);
      printf("CS_Ratio: %d\n", CS_Ratio);
    }
  }

  if(!Max_Radius) Max_Radius=Min_Radius;

  if(!Image_Name[0]) printf("ERROR:  No image specified\n");

  if (O_Target % (180/Num_Orientations))
  {
    printf("WARNING:  Orientation Target specified is not valid\n");
    printf("Processing will continue without a target\n");

    O_Target = 180;
  }

  if (O_Target < 180 && (!O_Contrast || I_Contrast))
  {
    printf("WARNING: Processing will continue with ");
    printf("Orientation Contrast activated and ");
    printf("Intensity Contrast de-activated\n");

    O_Contrast = 1;
  }

      printf("\n");
      printf("Image_Name: %s\n", Image_Name);
      printf("Num_Orientations: %d\n", Num_Orientations);
      printf("Levels: %d\n", Levels);
      printf("Sigma_c: %g\n", Sigma_c);
      printf("Sigma_s: %g\n", Sigma_s);
      printf("Intensity Contrast: %d\n", I_Contrast);
      printf("Orientation Contrast: %d\n", O_Contrast);
      printf("Min_Radius: %d\n", Min_Radius);
      printf("Max_Radius: %d\n", Max_Radius);
      printf("O_Target: %d\n", O_Target);
      printf("Threshold: %d\n", Threshold);
      printf("Output: %d\n", Output);
      printf("Output_Image: %s\n", Output_Image);
      printf("CS_Ratio: %d\n", CS_Ratio);

}

