#include <stdio.h>
#include <string.h>
#include "edges.h"
#include "pgm.h"
#include "user.h"

void parse(int argc, char *argv[], int *e_disp, int *f_disp,
	   int *c_disp, int *e_save, int *f_save, int *centre,
	   int *surround, char *file_name)
{
  int i;

  for(i=1; i<argc-1; i++)
  {
    if(!(strcmp(argv[i], "-ed"))) *e_disp=1;
    else if(!(strcmp(argv[i], "-fd"))) *f_disp=1;
    else if(!(strcmp(argv[i], "-cd"))) *c_disp=1;
    else if(!(strcmp(argv[i], "-es"))) *e_save=1;
    else if(!(strcmp(argv[i], "-fs"))) *f_save=1;
    else if(!(strcmp(argv[i], "-s")))
    {
      if (sscanf(argv[i+1], "%d", centre) !=1)
      {
        *centre=7;
        fprintf(stderr, "Invalid centre value: %s\n", argv[i+1]);
        fprintf(stderr, "Centre radius set to 7, Surround radius set to 12\n");
      }
      else
      {
        i++;
        if (sscanf(argv[i+1], "%d", surround) !=1)
        {
          *surround=10;
          fprintf(stderr, "Invalid surround value: %s\n", argv[i+2]);
	  fprintf(stderr, "Surround radius set to 12\n");
        }
	else
	  i++;
      }
    }
    else
      fprintf(stderr, "Invalid option: %s\n", argv[i]);
  }
  strcpy(file_name, argv[argc-1]);

}


void save_disp(int display, int save, char *file_name, 
	       unsigned char **map, int width, int height, 
	       int max, char *m_type)
{
  int s_index, s_ind2;
  int i;
  int num;
  char new_file[ORIENTATIONS][40];
  char syscall[60];

  s_index=strlen(file_name)-3;
  for (i=0; i<ORIENTATIONS; i++)
  {
    strcpy(new_file[i], file_name);
    new_file[i][s_index]=0;
    strcat(new_file[i], m_type);
    strcat(new_file[i], ".000.pgm");
    s_ind2=strlen(new_file[i])-5;

    num=i*180/ORIENTATIONS;
    while (num)
    {
      new_file[i][s_ind2]=(num%10)+'0';
      num=num/10;
      --s_ind2;
    }
    write_pgm(new_file[i], map[i], width, height, max);
  }

  /* display edge maps */
  if (display)
  {
    for (i=0; i<ORIENTATIONS; i++)
    {
      strcpy(syscall, "xv ");
      strcat(syscall, new_file[i]);
      strcat(syscall, " &");
      /*      system(syscall);*/
      printf("%s\n", syscall);
    }

    /*    if (!save)
    {
      for (i=0; i<ORIENTATIONS; i++)
      {
        strcpy(syscall, "rm ");
        strcat(syscall, new_file[i]);
        system(syscall);
      }
    }*/
  }

}
