#include <stdio.h>
#include <math.h>
#include "edges.h"
#include "pgm.h"

double norm[18]={1.0000000000,
                1.2126885586,
                1.2567539888,
                1.2708220767,
                1.2538198733,
                1.2566043513,
                1.2566651553,
                1.2503801486,
                1.2215806441,
                1.0023701706,
                1.2176146449,
                1.2429960514,
                1.2549644454,
                1.2800518511,
                1.2548244189,
                1.2774155012,
                1.2641971441,
                1.3828566235};
/*
double norm[18]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
*/

/*
main(int argc, char* argv[])
{
  int width, height, max;
  int i, j;
  int size;
  unsigned char *edge_map1;
  unsigned char *image;
  char base[20], fname[35];

  max=read_pgm(argv[1], &image, &width, &height);
  size=width*height;
  write_pgm("temp.pgm", image, width, height, max);

  Edges(width, height, size, edge_map1, image);

  strncpy(base, argv[1], strlen(argv[1])-3);
  base[strlen(argv[1])-3]=0;
  sprintf(fname, "%se000.pgm", base);
  write_pgm(fname, edge_map1[0], width, height, max);
  sprintf(fname, "%se030.pgm", base);
  write_pgm(fname, edge_map1[1], width, height, max);
  sprintf(fname, "%se060.pgm", base);
  write_pgm(fname, edge_map1[2], width, height, max);
  sprintf(fname, "%se090.pgm", base);
  write_pgm(fname, edge_map1[3], width, height, max);
  sprintf(fname, "%se120.pgm", base);
  write_pgm(fname, edge_map1[4], width, height, max);
  sprintf(fname, "%se150.pgm", base);
  write_pgm(fname, edge_map1[5], width, height, max);
}
*/

void Edges(int width, int height, int size, int *edge_map,
		unsigned char *image, int *mag)
{
  int i, j, edge;
  int radius=1;
  double temp_map[size];
  double temp_mag[size];
  char f_name[20];
  char base[20], fname[35];
  int max=255;
  FILE *out;

  for(i=0; i<size; i++)
    edge_map[i]=-1;

  for (i=radius; i<height-radius; i++)
  {
    for (j=radius; j<width-radius; j++)
    {
      edge_map[i*width+j]=Sobel(i, j, width, image, temp_mag);
    }
  }

  norm_mag(mag, temp_mag, size);

/*
  out=fopen("mag_data", "w");

  for (i=radius; i<height-radius; i++)
  {
    for (j=radius; j<width-radius; j++)
      fprintf(out, "%d ", mag[i*width+j]);
    fprintf(out, "\n");
  }

  fclose(out);
*/
}

int Sobel(int i, int j, int width, unsigned char *image, double *mag)
{
  float temp;
  double Sx, Sy, ratio;
  int result;

  static int X[9] = {-1,  0,  1,
		     -2,  0,  2,
		     -1,  0,  1 };

  static int Y[9] = {-1, -2, -1,
		      0,  0,  0,
		      1,  2,  1 };

  Sx=Grad(i, j, width, X, image);
  Sy=Grad(i, j, width, Y, image);
  mag[i*width+j]=sqrt(Sx*Sx+Sy*Sy);

  if (Sy==0.0)
  {
    if (Sx==0.0)  result=-1;
    else result=90;
  }
  else
  {
    ratio=Sx/Sy;
    if ((result=atan(ratio)*180/M_PI) < 0)
      result+=180;
  }

  return result;
}


double Grad(int i, int j, int width, int mask[9], unsigned char *image)
{
  int x, y;
  double total=0.0;
  int temp;

  i--; j--;

  for(y=0; y<3; y++)
    for(x=0; x<3; x++)
    {
      temp = mask[y*3+x] * image[(i+y)*width + (j+x)];
      total+=temp;
    }

  return total;

}

void norm_mag (int *to, double *from, int size)
{
  int i;
  double max=0, factor;

  for (i=0; i<size; i++)
    if (from[i]>max) max=from[i];

  factor=255.0/max;
  printf("norm_mag max=%g factor=%g\n", max, factor);

  for(i=0; i<size; i++)
  {
    to[i]=from[i]*factor;
  }
}
